  /*  prefs.c - powershell
   *  Copyright (C) 1999  Matt Spong <spong@glue.umd.edu>
   *  Based from zterm.c by Michael Zucci from the libzvt docs
   *
   *  A big, puffy lotsa-shells-in-one app. 
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License
   *  along with this program; if not, write to the Free Software
   *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * This code uses my patented "ugly-code" algorithm.  I'll fix it
 * at some point :-)
 */

#include "powershell.h"

ZvtTerm * current_term;

GtkWidget * widget, * widget2 ,* widget3, * widget4, * widget5;

preferences Prefs;


GtkWidget * pbox;

void property_changed (GtkWidget * w, gpointer user_data)
{
  gnome_property_box_changed (GNOME_PROPERTY_BOX(pbox));
}


static void property_apply (GnomePropertyBox *box, int page_num,
			    gpointer data)
{
  ApplyPrefsAppearance();
  ApplyPrefsColors();
  ApplyPrefsMenus();
  ApplyPrefsHandlers();
  ApplyPrefsShortcuts();

  WriteRCFile();
  UpdateAllTerms();
}



int DoPreferences ()
{
  pbox = gnome_property_box_new ();
  gtk_signal_connect (GTK_OBJECT(pbox), "apply",
		      GTK_SIGNAL_FUNC(property_apply), NULL);
  widget = gtk_vbox_new (FALSE, 0);

  CreatePrefsAppearance (widget);
  gnome_property_box_append_page (GNOME_PROPERTY_BOX(pbox),
				  widget,
				  gtk_label_new ("Appearance"));

#ifdef ZVT_USE_MATCHING
  widget2 = gtk_vbox_new (FALSE, 0);
  CreatePrefsHandlers (widget2);
  gnome_property_box_append_page (GNOME_PROPERTY_BOX(pbox),
				  widget2,
				  gtk_label_new ("Handlers"));
#endif

  widget4 = gtk_hbox_new (FALSE, 0);
  CreatePrefsColors (widget4);
  gnome_property_box_append_page (GNOME_PROPERTY_BOX(pbox),
				  widget4,
				  gtk_label_new ("Colors"));

  widget5 = gtk_hbox_new (FALSE, 0);
  CreatePrefsShortcuts (widget5);
  gnome_property_box_append_page (GNOME_PROPERTY_BOX(pbox),
				  widget5,
				  gtk_label_new ("Keyboard"));
 

  widget3 = gtk_vbox_new (FALSE, 0);
  CreatePrefsMenus (widget3);
  gnome_property_box_append_page (GNOME_PROPERTY_BOX(pbox),
				  widget3,
				  gtk_label_new ("Menus"));

  gtk_widget_show_all (pbox);
}

